// WTLCtlxDemo.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"

CAppModule _Module;

class CAboutDialog : public CSimpleDialog<IDD_ABOUT_DIALOG>, CWinDataExchange<CAboutDialog>
{
private:
	CBitmapButton m_wndBmpButton;
	CHyperLink m_wndHyperLink;

public:
	enum { IDD = IDD_ABOUT_DIALOG };

	BEGIN_MSG_MAP(CAboutDialog)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		CHAIN_MSG_MAP(CSimpleDialog<IDD_ABOUT_DIALOG>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CAboutDialog)
		DDX_CONTROL(IDOK, m_wndBmpButton)
		DDX_CONTROL(IDC_RSDNLINK, m_wndHyperLink)
	END_DDX_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		//   OK.
		DoDataExchange(FALSE, IDOK);

		m_wndBmpButton.SetBitmapButtonExtendedStyle(BMPBTN_HOVER | BMPBTN_AUTO3D_DOUBLE | BMPBTN_AUTOSIZE);
		CImageList il;
		il.Create(IDB_OK_BUTTON, 64, 0, -1);
		m_wndBmpButton.SetImageList(il);
		il.Detach();

		m_wndBmpButton.SetImages(0, 2, 1);
		m_wndBmpButton.SetToolTipText(_T("OK"));

		//  
		m_wndHyperLink.SetHyperLink(_T("mailto:rudankort@rsdn.ru"));
		DoDataExchange(FALSE, IDC_RSDNLINK);

		return 0;
	}
};

class CMainDialog : public CSimpleDialog<IDD_MAIN_DIALOG>, CWinDataExchange<CMainDialog>
{
private:
	CCheckListViewCtrl m_wndCheckList;
	CMultiPaneStatusBarCtrl m_wndStatusBar;

public:
	enum { IDD = IDD_MAIN_DIALOG };

	BEGIN_MSG_MAP(CMainDialog)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_HANDLER(IDC_ABOUT, BN_CLICKED, OnClickedAbout)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		NOTIFY_HANDLER(IDC_LIST, LVN_ITEMCHANGED, OnItemchangedList)
		CHAIN_MSG_MAP(CSimpleDialog<IDD_MAIN_DIALOG>)
	END_MSG_MAP()

	BEGIN_DDX_MAP(CMainDialog)
		DDX_CONTROL(IDC_LIST, m_wndCheckList)
		DDX_CONTROL(IDC_STATUS_BAR, m_wndStatusBar)
	END_DDX_MAP()

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		DoDataExchange(FALSE);

		//    .
		m_wndCheckList.InsertItem(0, _T("Item 1"));
		m_wndCheckList.InsertItem(1, _T("Item 2"));
		m_wndCheckList.InsertItem(2, _T("Item 3"));
		m_wndCheckList.InsertItem(3, _T("Item 4"));

		//     .
		int panes[] = { ID_DEFAULT_PANE, 1, 2, 3, 4 };
		m_wndStatusBar.SetPanes(panes, sizeof(panes)/sizeof(int), false);
		m_wndStatusBar.UpdatePanesLayout();

		return 0;
	}

	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		::SendMessage(GetDlgItem(IDC_STATUS_BAR), WM_SIZE, 0, 0);
		return 0;
	}

	LRESULT OnClickedAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		CAboutDialog dlg;
		dlg.DoModal();

		return 0;
	}

	LRESULT OnItemchangedList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
	{
		//    ,       .
		NMLISTVIEW *pInfo = (NMLISTVIEW *)pnmh;
		int item = pInfo->iItem;
		m_wndStatusBar.SetPaneText(item+1, m_wndCheckList.GetCheckState(item) ? _T("X") : _T(""));
		return 0;
	}
};


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	::InitCommonControls();

 	_Module.Init(NULL, hInstance);

	CMainDialog dlg;
	dlg.DoModal();

	_Module.Term();

	return 0;
}

